<html>
<head>
<title>OgreGLXGLSupport.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_5bc5f2f46c6364f2594540d45df3d051.html">GL</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7b8a29f58b064e3a63f570f2fc89729.html">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_222f5522bf7ba01b34ef163cdd511470.html">GLX</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLXGLSupport.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLXGLSupport_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="preprocessor">#ifndef OGRE_GLXGLSupport_H</span>
<a name="l00002"></a>00002 <span class="preprocessor"></span><span class="preprocessor">#define OGRE_GLXGLSupport_H</span>
<a name="l00003"></a>00003 <span class="preprocessor"></span>
<a name="l00004"></a>00004 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLSupport_8h.html">OgreGLSupport.h</a>&quot;</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="preprocessor">#include &lt;GL/glew.h&gt;</span>
<a name="l00007"></a>00007 <span class="preprocessor">#include &lt;GL/glxew.h&gt;</span>
<a name="l00008"></a>00008 
<a name="l00009"></a>00009 <span class="keyword">namespace </span>Ogre {
<a name="l00010"></a>00010 
<a name="l00011"></a><a class="code" href="classOgre_1_1GLXGLSupport.html">00011</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#af4c2f5df97e3050dd5266408be42db4b">_OgrePrivate</a> <a class="code" href="classOgre_1_1GLXGLSupport.html">GLXGLSupport</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1GLSupport.html">GLSupport</a>
<a name="l00012"></a>00012     {
<a name="l00013"></a>00013     <span class="keyword">public</span>:
<a name="l00014"></a>00014         <a class="code" href="classOgre_1_1GLXGLSupport.html">GLXGLSupport</a>();
<a name="l00015"></a>00015         ~<a class="code" href="classOgre_1_1GLXGLSupport.html">GLXGLSupport</a>();
<a name="l00016"></a>00016         
<a name="l00017"></a><a class="code" href="classOgre_1_1GLXGLSupport.html#a6199ce9222ad9d532bc30e28274be995">00017</a>         Atom <a class="code" href="classOgre_1_1GLXGLSupport.html#a6199ce9222ad9d532bc30e28274be995">mAtomDeleteWindow</a>;
<a name="l00018"></a><a class="code" href="classOgre_1_1GLXGLSupport.html#afffcd4e35f1b1157cfc0b96e55847190">00018</a>         Atom <a class="code" href="classOgre_1_1GLXGLSupport.html#afffcd4e35f1b1157cfc0b96e55847190">mAtomFullScreen</a>;
<a name="l00019"></a><a class="code" href="classOgre_1_1GLXGLSupport.html#a405ef4220560aa43924e061e14991f38">00019</a>         Atom <a class="code" href="classOgre_1_1GLXGLSupport.html#a405ef4220560aa43924e061e14991f38">mAtomState</a>;
<a name="l00020"></a>00020         
<a name="l00022"></a>00022         <span class="keywordtype">void</span> addConfig(<span class="keywordtype">void</span>);
<a name="l00023"></a>00023         
<a name="l00025"></a>00025         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> validateConfig(<span class="keywordtype">void</span>);
<a name="l00026"></a>00026         
<a name="l00028"></a>00028         <span class="keywordtype">void</span> setConfigOption(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;value);
<a name="l00029"></a>00029         
<a name="l00031"></a>00031         <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* createWindow(<span class="keywordtype">bool</span> autoCreateWindow, <a class="code" href="classOgre_1_1GLRenderSystem.html" title="Implementation of GL as a rendering system.">GLRenderSystem</a>* renderSystem, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; windowTitle);
<a name="l00032"></a>00032         
<a name="l00034"></a>00034         <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* newWindow(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> height, 
<a name="l00035"></a>00035                                 <span class="keywordtype">bool</span> fullScreen, <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a> *miscParams = 0);
<a name="l00036"></a>00036         
<a name="l00038"></a>00038         <a class="code" href="classOgre_1_1GLPBuffer.html" title="An off-screen rendering context.">GLPBuffer</a>* createPBuffer(<a class="code" href="group__Image.html#gac8f59c884998d9f84d9ea4c66e4c29fe" title="Pixel component format.">PixelComponentType</a> format, <span class="keywordtype">size_t</span> width, <span class="keywordtype">size_t</span> height);
<a name="l00039"></a>00039         
<a name="l00041"></a>00041         <span class="keywordtype">void</span> start();
<a name="l00042"></a>00042         
<a name="l00044"></a>00044         <span class="keywordtype">void</span> stop();
<a name="l00045"></a>00045         
<a name="l00047"></a>00047         <span class="keywordtype">void</span> initialiseExtensions();
<a name="l00048"></a>00048         
<a name="l00050"></a>00050         <span class="keywordtype">void</span>* getProcAddress(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; procname);
<a name="l00051"></a>00051         
<a name="l00052"></a>00052         <span class="comment">// The remaining functions are internal to the GLX Rendersystem:</span>
<a name="l00053"></a>00053         
<a name="l00067"></a>00067         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getDisplayName (<span class="keywordtype">void</span>);
<a name="l00068"></a>00068         
<a name="l00076"></a>00076         Display* getGLDisplay(<span class="keywordtype">void</span>);
<a name="l00077"></a>00077         
<a name="l00083"></a>00083         Display* getXDisplay(<span class="keywordtype">void</span>);
<a name="l00084"></a>00084         
<a name="l00092"></a>00092         <span class="keywordtype">void</span> switchMode (<a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a>&amp; width, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a>&amp; height, <span class="keywordtype">short</span>&amp; frequency);
<a name="l00093"></a>00093         
<a name="l00097"></a>00097         <span class="keywordtype">void</span> switchMode (<span class="keywordtype">void</span>);
<a name="l00098"></a>00098         
<a name="l00110"></a>00110         <span class="keywordtype">bool</span> loadIcon(<span class="keyword">const</span> std::string &amp;name, Pixmap *pix, Pixmap *mask);
<a name="l00111"></a>00111         
<a name="l00118"></a>00118         GLXFBConfig getFBConfigFromContext (::<a class="code" href="classOgre_1_1GLXContext.html">GLXContext</a> context);
<a name="l00119"></a>00119         
<a name="l00129"></a>00129         GLXFBConfig getFBConfigFromDrawable (GLXDrawable drawable, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> *width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> *height);
<a name="l00130"></a>00130         
<a name="l00139"></a>00139         GLXFBConfig selectFBConfig(<span class="keyword">const</span> <span class="keywordtype">int</span> *minAttribs, <span class="keyword">const</span> <span class="keywordtype">int</span> *maxAttribs);
<a name="l00140"></a>00140         
<a name="l00151"></a>00151         GLXFBConfig getFBConfigFromVisualID(VisualID visualid);
<a name="l00152"></a>00152         
<a name="l00156"></a>00156         GLXFBConfig* chooseFBConfig(<span class="keyword">const</span> GLint *attribList, GLint *nElements);
<a name="l00157"></a>00157         
<a name="l00161"></a>00161         <a class="code" href="classOgre_1_1GLXContext.html">::GLXContext</a> createNewContext(GLXFBConfig fbConfig, GLint renderType, ::<a class="code" href="classOgre_1_1GLXContext.html">GLXContext</a> shareList, GLboolean direct) <span class="keyword">const</span>;
<a name="l00162"></a>00162         
<a name="l00166"></a>00166         GLint getFBConfigAttrib(GLXFBConfig fbConfig, GLint attribute, GLint *value);
<a name="l00167"></a>00167         
<a name="l00171"></a>00171         XVisualInfo* getVisualFromFBConfig(GLXFBConfig fbConfig);
<a name="l00172"></a>00172         
<a name="l00173"></a>00173         <span class="keyword">private</span>:
<a name="l00177"></a>00177         <span class="keywordtype">void</span> initialiseGLXEW(<span class="keywordtype">void</span>);
<a name="l00178"></a>00178         
<a name="l00182"></a>00182         <span class="keywordtype">void</span> refreshConfig(<span class="keywordtype">void</span>);
<a name="l00183"></a>00183         
<a name="l00184"></a><a class="code" href="classOgre_1_1GLXGLSupport.html#a0c3c624f717a2d109e826f728865f4db">00184</a>         Display* <a class="code" href="classOgre_1_1GLXGLSupport.html#a0c3c624f717a2d109e826f728865f4db">mGLDisplay</a>; <span class="comment">// used for GL/GLX commands</span>
<a name="l00185"></a><a class="code" href="classOgre_1_1GLXGLSupport.html#a6597c02438917f4bc92d3e5f35895788">00185</a>         Display* <a class="code" href="classOgre_1_1GLXGLSupport.html#a6597c02438917f4bc92d3e5f35895788">mXDisplay</a>;  <span class="comment">// used for other X commands and events</span>
<a name="l00186"></a><a class="code" href="classOgre_1_1GLXGLSupport.html#a1c0bcd19e502f33bea872466e09164bf">00186</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLXGLSupport.html#a1c0bcd19e502f33bea872466e09164bf">mIsExternalDisplay</a>;
<a name="l00187"></a>00187         
<a name="l00188"></a><a class="code" href="classOgre_1_1GLXGLSupport.html#ae087102342a2a84abd6dd46b1d01efb3">00188</a>         <span class="keyword">typedef</span> std::pair&lt;uint, uint&gt;      <a class="code" href="classOgre_1_1GLXGLSupport.html#ae087102342a2a84abd6dd46b1d01efb3">ScreenSize</a>;
<a name="l00189"></a><a class="code" href="classOgre_1_1GLXGLSupport.html#af5da5650fe15484f994a296d41f5f574">00189</a>         <span class="keyword">typedef</span> <span class="keywordtype">short</span>                      <a class="code" href="classOgre_1_1GLXGLSupport.html#af5da5650fe15484f994a296d41f5f574">Rate</a>;
<a name="l00190"></a><a class="code" href="classOgre_1_1GLXGLSupport.html#a0954bbdc22d42e139ed6dcf7aaaf7f57">00190</a>         <span class="keyword">typedef</span> std::pair&lt;ScreenSize, Rate&gt; <a class="code" href="classOgre_1_1GLXGLSupport.html#a0954bbdc22d42e139ed6dcf7aaaf7f57">VideoMode</a>;
<a name="l00191"></a><a class="code" href="classOgre_1_1GLXGLSupport.html#aacb66a96f340e55f923314e764d6ed3b">00191</a>         <span class="keyword">typedef</span> std::vector&lt;VideoMode&gt;    <a class="code" href="classOgre_1_1GLXGLSupport.html#aacb66a96f340e55f923314e764d6ed3b">VideoModes</a>;
<a name="l00192"></a>00192         
<a name="l00193"></a><a class="code" href="classOgre_1_1GLXGLSupport.html#a63f609cd26fbfc515020d5f6104e88dc">00193</a>         <a class="code" href="classOgre_1_1GLXGLSupport.html#aacb66a96f340e55f923314e764d6ed3b">VideoModes</a> <a class="code" href="classOgre_1_1GLXGLSupport.html#a63f609cd26fbfc515020d5f6104e88dc">mVideoModes</a>;
<a name="l00194"></a><a class="code" href="classOgre_1_1GLXGLSupport.html#a1ff7162046fa546bb61305a73dd45505">00194</a>         <a class="code" href="classOgre_1_1GLXGLSupport.html#a0954bbdc22d42e139ed6dcf7aaaf7f57">VideoMode</a>  <a class="code" href="classOgre_1_1GLXGLSupport.html#a1ff7162046fa546bb61305a73dd45505">mOriginalMode</a>;
<a name="l00195"></a><a class="code" href="classOgre_1_1GLXGLSupport.html#a5cc8699092034a0bfc35b9a96d228a92">00195</a>         <a class="code" href="classOgre_1_1GLXGLSupport.html#a0954bbdc22d42e139ed6dcf7aaaf7f57">VideoMode</a>  <a class="code" href="classOgre_1_1GLXGLSupport.html#a5cc8699092034a0bfc35b9a96d228a92">mCurrentMode</a>;
<a name="l00196"></a>00196         
<a name="l00197"></a><a class="code" href="classOgre_1_1GLXGLSupport.html#a1d2ef9a0841db617d9c28bdc65248949">00197</a>         <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a> <a class="code" href="classOgre_1_1GLXGLSupport.html#a1d2ef9a0841db617d9c28bdc65248949">mSampleLevels</a>;
<a name="l00198"></a>00198     };
<a name="l00199"></a>00199 }
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 <span class="preprocessor">#endif // OGRE_GLXGLSupport_H</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
